<a href="https://www.energietechnik.tu-berlin.de/menue/forschung/energiesystemanalyse_und_optimierung/oeb_ensys/"><img src="https://www.energietechnik.tu-berlin.de/fileadmin/fg106/Fotos/aristopy_logo_small.png" alt="aristopy Logo" width="300px"></a>

# Optimizing energy systems with *aristopy*


The Python package *aristopy* is a framework for modeling and optimizing the
design and operation of energy systems.
The name of the framework is derived from the great Greek thinker Aristotle.
For Aristotle, planning and the wise use of human goods represented great virtues.
Transferred to today's time and the design of energy systems, this implies using
appropriate tools that support the planning process and contribute to an
optimal use of the available resources (money, fuel, etc.).

##  Selected highlights
* Flexible modeling of energy systems with only a small number of basic
  components (Source, Sink, Conversion, Bus, Storage) and a comprehensive API.
* Manual scripting of component constraints to enable all types of
  mathematical modeling classes (linear \[LP\], mixed-integer linear
  \[MILP\], mixed-integer non-linear \[MINLP\], etc.).

* Declaration of persistent models to quickly run models iteratively
  after applying small changes (e.g., add an integer-cut constraint).
* Auto-generated visualization of the optimization results with
  flexible plotting routines.

## Documentation
The package documentation is hosted on readthedocs.org and can be accessed
[here](https://aristopy.readthedocs.io/en/latest/index.html).

## Installation
Precise installation instructions are added soon.

Until then, try to install *aristopy* in your current environment via
pip by using the following command:

```python
pip install aristopy
```

## Examples
Links to example repositories are added soon.

## Citing and Contributing
You are welcome to test aristopy and use it for your own purposes. If you
publish results based on the application of the package, we kindly ask you to
cite this GitHub repository or the [project documentation](
https://aristopy.readthedocs.io/en/latest/index.html) on readthedocs.org.

If you have questions, found a bug or what to contribute to the development of
*aristopy* you are invited to open an issue or contact the developers
(stefan-bruche@tu-berlin.de).

## License
[MIT License](https://opensource.org/licenses/MIT)

Copyright (c) 2020 Stefan Bruche (TU Berlin)

## Acknowledgement
This work was developed during the research project "MINLP-Optimization of
Design and Operation of Complex Energy Systems", funded by the German Federal
Ministry for Economic Affairs and Energy (project reference number 03ET4053A).
The funding is gratefully acknowledged.

<a href="https://www.energietechnik.tu-berlin.de/menue/forschung/energiesystemanalyse_und_optimierung/oeb_ensys/"><img src="https://www.energietechnik.tu-berlin.de/fileadmin/fg106/Fotos/bwmi_logo_small.png" alt="BMWi Logo" width="200px"></a>